Index: issm/trunk/src/m/plot/plot_manager.js
===================================================================
--- issm/trunk/src/m/plot/plot_manager.js	(revision 25994)
+++ issm/trunk/src/m/plot/plot_manager.js	(revision 26744)
@@ -1,130 +1,162 @@
-function plot_manager(md,options,subplotwidth,nlines,ncols,i){ //{{{
+'use strict';
+
+function plot_manager(md, options, subplotwidth, nlines, ncols, i) { //{{{
 	//PLOT__MANAGER - distribute the plots, called by plotmodel
 	//
 	//   Usage:
-	//      plot_manager(md,options,subplotwidth,i);
+	//      plot_manager(md, options, subplotwidth, i);
 	//
 	//   See also: PLOTMODEL, PLOT_UNIT
+	let canvas      = document.getElementById(options.getfieldvalue('canvasid'));
+	let data        = options.getfieldvalue('data'); // Get data to be displayed
+	let dataresults = null; 
+	let datatype    = 0;
+	let	data2       = null;
 			
-	//parse options and get a structure of options. 
-	checkplotoptions(md,options);
-	
-	//get data to be displayed
-	var data = options.getfieldvalue('data');
-	var canvas = initCanvas(options);
-	var gl = canvas.gl;
-
-	//figure out if this is a special plot
-	if (typeof data === 'string'){
-		
-		switch(data){
-
+	// Parse options and get a structure of options
+	checkplotoptions(md, options);
+
+	// Figure out if this is a special plot
+	if (typeof data === 'string') {
+		switch(data) {
 			case 'boundaries':
-				plot_boundaries(md,options,subplotwidth,i);
-				return;
+				plot_boundaries(md, options, subplotwidth, i);
+				return;
+				
 			case 'BC':
-				plot_BC(md,options,subplotwidth,i,data);
-				return;
+				plot_BC(md, options, subplotwidth, i, data);
+				return;
+				
 			case 'edges':
-				plot_edges(md,options,subplotwidth,i,data);
-				return;
+				plot_edges(md, options, subplotwidth, i, data);
+				return;
+				
 			case 'elementnumbering':
-				plot_elementnumbering(md,options,subplotwidth,i);
-				return;
+				plot_elementnumbering(md, options, subplotwidth, i);
+				return;
+				
 			case 'highlightelements':
-				plot_highlightelements(md,options,subplotwidth,i);
-				return;
+				plot_highlightelements(md, options, subplotwidth, i);
+				return;
+				
 			case 'qmumean':
-				plot_qmumean(md,options,nlines,ncols,i);
-				return;
+				plot_qmumean(md, options, nlines, ncols, i);
+				return;
+				
 			case 'qmustddev':
-				plot_qmustddev(md,options,nlines,ncols,i);
-				return;
+				plot_qmustddev(md, options, nlines, ncols, i);
+				return;
+				
 			case 'qmuhistnorm':
-				plot_qmuhistnorm(md,options,nlines,ncols,i);
-				return;
+				plot_qmuhistnorm(md, options, nlines, ncols, i);
+				return;
+				
 			case 'qmu_mass_flux_segments':
-				plot_qmu_mass_flux_segments(md,options,nlines,ncols,i);
-				return;
+				plot_qmu_mass_flux_segments(md, options, nlines, ncols, i);
+				return;
+				
 			case 'part_hist':
-				plot_parthist(md,options,nlines,ncols,i);
-				return;
+				plot_parthist(md, options, nlines, ncols, i);
+				return;
+				
 			case 'part_hist_n':
-				plot_parthistn(md,options,nlines,ncols,i);
-				return;
+				plot_parthistn(md, options, nlines, ncols, i);
+				return;
+				
 			case 'part_hist_w':
-				plot_parthistw(md,options,nlines,ncols,i);
-				return;
+				plot_parthistw(md, options, nlines, ncols, i);
+				return;
+				
 			case 'elements_type':
-				plot_elementstype(md,options,subplotwidth,i);
-				return;
+				plot_elementstype(md, options, subplotwidth, i);
+				return;
+				
 			case 'vertexnumbering':
-				plot_vertexnumbering(md,options,subplotwidth,i);
-				return;
+				plot_vertexnumbering(md, options, subplotwidth, i);
+				return;
+				
 			case 'highlightvertices':
-				plot_highlightvertices(md,options,subplotwidth,i);
-				return;
+				plot_highlightvertices(md, options, subplotwidth, i);
+				return;
+				
 			case 'basal_drag':
-				plot_basaldrag(md,options,subplotwidth,i,data);
-				return;
+				plot_basaldrag(md, options, subplotwidth, i, data);
+				return;
+				
 			case 'basal_dragx':
-				plot_basaldrag(md,options,subplotwidth,i,data);
-				return;
+				plot_basaldrag(md, options, subplotwidth, i, data);
+				return;
+				
 			case 'basal_dragy':
-				plot_basaldrag(md,options,subplotwidth,i,data);
-				return;
+				plot_basaldrag(md, options, subplotwidth, i, data);
+				return;
+				
 			case 'driving_stress':
-				plot_drivingstress(md,options,subplotwidth,i);
-				return;
+				plot_drivingstress(md, options, subplotwidth, i);
+				return;
+				
 			case 'mesh':
-				plot_mesh(md,options,canvas);
-				return;
+				plot_mesh(md, options, canvas);
+				return;
+				
 			case 'none':
-				//if (!(options.exist('overlay'))){
-				//	plot_none(md,options,nlines,ncols,i);
-				//}
-				return;
+				return;
+				
 			case 'penalties':
-				plot_penalties(md,options,subplotwidth,i);
-				return;
+				plot_penalties(md, options, subplotwidth, i);
+				return;
+				
 			case 'partition':
-				plot_partition(md,options,nlines,ncols,i);
-				return;
+				plot_partition(md, options, nlines, ncols, i);
+				return;
+				
 			case 'referential':
-				plot_referential(md,options,nlines,ncols,i);
-				return;
+				plot_referential(md, options, nlines, ncols, i);
+				return;
+				
 			case 'riftvel':
-				plot_riftvel(md,options,nlines,ncols,i);
-				return;
+				plot_riftvel(md, options, nlines, ncols, i);
+				return;
+				
 			case 'riftnumbering':
-				plot_riftnumbering(md,options,nlines,ncols,i);
-				return;
+				plot_riftnumbering(md, options, nlines, ncols, i);
+				return;
+				
 			case 'rifts':
-				plot_rifts(md,options,nlines,ncols,i);
-				return;
+				plot_rifts(md, options, nlines, ncols, i);
+				return;
+				
 			case 'riftrelvel':
-				plot_riftrelvel(md,options,nlines,ncols,i);
-				return;
+				plot_riftrelvel(md, options, nlines, ncols, i);
+				return;
+				
 			case 'riftpenetration':
-				plot_riftpenetration(md,options,nlines,ncols,i);
-				return;
+				plot_riftpenetration(md, options, nlines, ncols, i);
+				return;
+				
 			case 'riftfraction':
-				plot_riftfraction(md,options,nlines,ncols,i);
-				return;
+				plot_riftfraction(md, options, nlines, ncols, i);
+				return;
+				
 			case 'sarpwr':
-				plot_sarpwr(md,options,subplotwidth,i);
-				return;
+				plot_sarpwr(md, options, subplotwidth, i);
+				return;
+				
 			case 'time_dependant':
-				plot_vstime(md,options,nlines,ncols,i);
-				return;
+				plot_vstime(md, options, nlines, ncols, i);
+				return;
+				
 			case 'icefront':
-				plot_icefront(md,options,subplotwidth,i,data);
-				return;
+				plot_icefront(md, options, subplotwidth, i, data);
+				return;
+				
 			case 'segments':
-				plot_segments(md,options,subplotwidth,i,data);
-				return;
+				plot_segments(md, options, subplotwidth, i, data);
+				return;
+				
 			case 'quiver':
-				plot_quiver(md,options,canvas);
-				return;
+				plot_quiver(md, options, canvas);
+				return;
+				
 			case 'strainrate_tensor':
 			case 'strainrate':
@@ -145,23 +177,27 @@
 			case 'deviatoricstress_principalaxis2':
 			case 'deviatoricstress_principalaxis3':
-				plot_tensor(md,options,subplotwidth,i,data);
-				return;
+				plot_tensor(md, options, subplotwidth, i, data);
+				return;
+				
 			case 'thermaltransient_results':
-				plot_thermaltransient_results(md,options,subplotwidth,i);
-				return;
+				plot_thermaltransient_results(md, options, subplotwidth, i);
+				return;
+				
 			case 'transient_movie':
-				plot_transient_movie(md,options,canvas);
-				return;
+				plot_transient_movie(md, options, canvas);
+				return;
+				
 			case 'transient_results':
-				plot_transient_results(md,options,subplotwidth,i);
-				return;
+				plot_transient_results(md, options, subplotwidth, i);
+				return;
+				
 			case 'transient_field':
-				plot_transient_field(md,options,subplotwidth,i);
-				return;
+				plot_transient_field(md, options, subplotwidth, i);
+				return;
+				
 			default:
-				if (data in md){
-					data=md[data];
-				}
-				else{
+				if (data in md) {
+					data = md[data];
+				} else {
 					error('plot error message: data provided not supported yet. Type plotdoc for help');
 				}
@@ -169,40 +205,41 @@
 	}
 
-	//Figure out if this is a semi-transparent plot.
-	if (options.getfieldvalue('overlay','off')=='on'){
-		plot_overlay(md,data,options,canvas);
-	}
-
-	//Figure out if this is a semi-transparent plot.
-	if (options.exist('googlemaps')){
-		plot_googlemaps(md,data,options,nlines,ncols,i);
-		return;
-	}
-
-	//Figure out if this is a semi-transparent plot.
-	if (options.exist('gridded')){
-		plot_gridded(md,data,options,nlines,ncols,i);
-		return;
-	}
-
-	//Figure out if this is a Section plot
-	if (options.exist('sectionvalue')){
-		plot_section(md,data,options,nlines,ncols,i);
+	// Figure out if this is a semi-transparent plot.
+	if (options.getfieldvalue('overlay', 'off') === 'on') {
+		plot_overlay(md, data, options, canvas);
+		//return;
+	}
+
+	// Figure out if this is a semi-transparent plot.
+	if (options.exist('googlemaps')) {
+		plot_googlemaps(md, data, options, nlines, ncols, i);
+		return;
+	}
+
+	// Figure out if this is a semi-transparent plot.
+	if (options.exist('gridded')) {
+		plot_gridded(md, data, options, nlines, ncols, i);
+		return;
+	}
+
+	// Figure out if this is a Section plot
+	if (options.exist('sectionvalue')) {
+		plot_section(md, data, options, nlines, ncols, i);
 		return;
 	}
 
 	//Figure out if this is a Profile plot
-	if (options.exist('profile')){
-		plot_profile(md,data,options,nlines,ncols,i);
+	if (options.exist('profile')) {
+		plot_profile(md, data, options, nlines, ncols, i);
 		return;
 	}
 	
-	var	dataresults = processdata(md,data,options);
-	var	data2 = dataresults[0]; 
-	var	datatype = dataresults[1];
+	dataresults = processdata(md, data, options);
+	data2       = dataresults[0]; 
+	datatype    = dataresults[1];
 	
-	//plot unit
-	plot_unit(md,data2,datatype,options,canvas);
-
-	applyoptions(md,data2,options,canvas);
+	// Plot unit
+	plot_unit(md, data2, datatype, options, canvas);
+
+	applyoptions(md, data2, options, canvas);
 } //}}}
Index: issm/trunk/src/m/plot/plot_manager.py
===================================================================
--- issm/trunk/src/m/plot/plot_manager.py	(revision 25994)
+++ issm/trunk/src/m/plot/plot_manager.py	(revision 26744)
@@ -3,5 +3,5 @@
     overlaysupport = True
 except ImportError:
-    print('osgeo/gdal for python not installed, overlay plots are not enabled')
+    print('OSGeo/GDAL for Python not installed, overlay plots are not enabled')
     overlaysupport = False
 
@@ -20,6 +20,5 @@
 
 def plot_manager(md, options, fig, axgrid, gridindex):
-    '''
-    PLOT_MANAGER - distribute the plots called by plotmodel
+    """PLOT_MANAGER - distribute the plots called by plotmodel
 
     'fig' is a handle to the figure instance created by plotmodel.
@@ -35,5 +34,5 @@
 
     See also: PLOTMODEL, PLOT_UNIT
-    '''
+    """
     #parse options and get a structure of options
     options = checkplotoptions(md, options)
@@ -46,4 +45,5 @@
     # TODO: Check why we are doing this and if it is absolutely necessary (see
     #       also src/m/plot/plot_mesh.py, src/m/plot/applyoptions.py)
+    #
     options.addfielddefault('ticklabels', 'on')
 
Index: issm/trunk/src/m/plot/plot_mesh.js
===================================================================
--- issm/trunk/src/m/plot/plot_mesh.js	(revision 25994)
+++ issm/trunk/src/m/plot/plot_mesh.js	(revision 26744)
@@ -7,64 +7,47 @@
 	//   See also: PLOTMODEL, PLOT_MANAGER
 
-	// If we already have the overlay and are using caching, short circuit
-	if ('mesh' in canvas.nodes && options.getfieldvalue('cachenodes', 'off') === 'on') {
-		return;
-	}
-	
-	/*
-		Local variables
-	*/
 	//{{{
 	//Process data and model
-	var meshresults = processmesh(md, [], options);
-	var x = meshresults[0]; 
-	var y = meshresults[1]; 
-	var z = meshresults[2]; 
-	var elements = meshresults[3]; 
-	var is2d = meshresults[4]; 
-	var isplanet = meshresults[5];
-		
-	//Compute coordinates and data range:
-	var xlim = options.getfieldvalue('xlim', [ArrayMin(x), ArrayMax(x)]);
-	var ylim = options.getfieldvalue('ylim', [ArrayMin(y), ArrayMax(y)]);
-	var zlim = options.getfieldvalue('zlim', [ArrayMin(z), ArrayMax(z)]);
-	
-	//Handle heightscale
-	var vertices, scale;
-	if (md.mesh.classname() !== 'mesh3dsurface') {
-		vertices = [x, y, z];
-		scale = [1, 1, options.getfieldvalue('heightscale', 1)];
-	}
-	else {
-		vertices = Node.prototype.scaleVertices(md, x, y, z, elements, options.getfieldvalue('heightscale', 1), options.getfieldvalue('maskregion',{'enabled':false}));
-		scale = [1, 1, 1];
-	}
+	let meshresults = processmesh(md, [], options);
+	meshresults = scaleMesh(md, meshresults, options);
+	let x = meshresults[0]; 
+	let y = meshresults[1]; 
+	let z = meshresults[2]; 
+	let elements = meshresults[3];
+	let is2d = meshresults[4]; 
+	let isplanet = meshresults[5];
+	let vertices = meshresults[6];
+	let scale = meshresults[7];
 	
 	//Compute gl variables:
-	var edgecolor = options.getfieldvalue('edgecolor', 'black');
-	var node = new Node(
+	let edgecolor = options.getfieldvalue('edgecolor', 'black');
+	let node = new Node(
 		'canvas', canvas,
 		'options', options,
+		'md', md,
 		'name', 'mesh',
-		'shaderName', 'Colored',
-		'alpha', options.getfieldvalue('alpha', 1.0),
-		//'center', [(xlim[0] + xlim[1]) / 2, (ylim[0] + ylim[1]) / 2, md.mesh.classname() === 'mesh3dsurface' ? (zlim[0] + zlim[1]) / 2 : zlim[0]],
-		'center', [(xlim[0] + xlim[1]) / 2, (ylim[0] + ylim[1]) / 2, (zlim[0] + zlim[1]) / 2],
-		'drawMode', canvas.gl.LINES,
-		'diffuseColor', edgecolor,
+		'cullFace', THREE.DoubleSide,
+		'shaderName', 'lines',
+		'opacity', options.getfieldvalue('opacity', 1.0),
 		'lineWidth', options.getfieldvalue('linewidth', 1),
-		'maskEnabled', options.getfieldvalue('innermask','off') == 'on',
-		'maskHeight', options.getfieldvalue('innermaskheight', 150.0) / options.getfieldvalue('heightscale', 1),
-		'maskColor', options.getfieldvalue('innermaskcolor',[0.0, 0.0, 1.0, 1.0]),
-		'rotation', [-90, 0, 0],
 		'scale', scale
 	);
 	//}}}
 	//{{{ node plot
-	if (elements[0].length==6){ //prisms
-	}
-	else if (elements[0].length==4){ //tetras
-	}
-	else{ //2D triangular elements
+	if (elements[0].length === 6) { //prisms
+		//We can skip bottom and every other side to avoid drawing edges twice.
+		let abc = elements.map(function(value, index) { return [value[0], value[1], value[2]]; }); //top
+		// let dfe = elements.map(function(value, index) { return [value[3], value[5], value[4]]; }); //bottom
+		// let aeb = elements.map(function(value, index) { return [value[0], value[4], value[1]]; }); //1st side upper right
+		let ade = elements.map(function(value, index) { return [value[0], value[3], value[4]]; }); //1st side lower left
+		// let bfc = elements.map(function(value, index) { return [value[1], value[5], value[2]]; }); //2nd side upper right
+		let bef = elements.map(function(value, index) { return [value[1], value[4], value[5]]; }); //2nd side lower left
+		// let cda = elements.map(function(value, index) { return [value[2], value[3], value[0]]; }); //3rd side upper right
+		let cfd = elements.map(function(value, index) { return [value[2], value[5], value[3]]; }); //3rd side lower left
+		let prismElements = abc.concat(ade, bef, cfd);
+		node.patch('Faces', prismElements, 'Vertices', vertices, 'FaceColor', 'none', 'EdgeColor', edgecolor);
+	} else if (elements[0].length === 4) { //tetras
+        // TODO: Implement handling for tetras
+	} else { // 2D triangular elements
 		node.patch('Faces', elements, 'Vertices', vertices, 'FaceColor', 'none', 'EdgeColor', edgecolor);
 	}
Index: issm/trunk/src/m/plot/plot_overlay.js
===================================================================
--- issm/trunk/src/m/plot/plot_overlay.js	(revision 25994)
+++ issm/trunk/src/m/plot/plot_overlay.js	(revision 26744)
@@ -1,98 +1,157 @@
-function plot_overlay(md, data, options, canvas){ //{{{
-	//PLOT_OVERLAY - Function for plotting a georeferenced image.  
-	//
-	//   Usage:
-	//      plot_overlay(md, data, options, canvas);
-	//
-	//   See also: PLOTMODEL, PLOT_MANAGER
+'use strict';
 
-	// If we already have the overlay and are using caching, short circuit
-	if ('overlay' in canvas.nodes && options.getfieldvalue('cachenodes', 'off') === 'on') {
-		return;
+/**
+ * Global Function: plotOverlay
+ *
+ * Plot a georeferenced image 
+ *
+ * Dependencies:
+ *      - /ext/proj4-<version>
+ *
+ * See Also:
+ *      - /js/plotmodel.js
+ *      - /js/plotmanager.js
+ */
+function plot_overlay(md, data, options, canvas) {
+    let elements        = null;
+    let meshresults     = null; // results from call to processmesh
+    let newX            = null; // scaled x-coordinates (array)
+    let newY            = null; // scaled y-coordinates (array)
+    let newZ            = null; // scaled z-coordinates (array)
+    let position        = null; // x-, y-, and z-coordinates of vertex (object)
+    let renderObject    = null; 
+    let reproject       = false; // default; whether or not to reproject overlay
+    let result          = null; // First, projection of radar overlay onto mesh; then, projection of overlay onto mesh
+    let scale           = null; // coordinate scalars (array)
+	let vertices        = null;
+    let x               = null; // x-coordinates from results (array)
+    let xlim            = null; // x-cooridinate limits (array)
+    let y               = null; // y-coordinates from results (array)
+    let ylim            = null; // y-cooridinate limits (array)
+    let z               = null; // z-coordinates from results (array)
+    
+	// Process data and model
+    meshresults = processmesh(md, [], options);
+	x           = meshresults[0]; 
+	y           = meshresults[1]; 
+	z           = meshresults[2]; 
+	elements    = meshresults[3];
+	
+	if (md.mesh.classname().startsWith('mesh2d')) {
+		if (vesl.helpers.isNaN(md.geometry.surface) || (md.geometry.surface[0] !== undefined && vesl.helpers.isNaN(md.geometry.surface[0]))) {
+			md.geometry.surface = NewArrayFill(x.length, 0);
+			z = NewArrayFill(x.length, 0);
+		} else {
+			z = md.geometry.surface;
+		}
 	}
 	
-	/*
-		Local variables
-	*/
-	//{{{
-	//Process data and model
-	var meshresults = processmesh(md, [], options);
-	var x = meshresults[0]; 
-	var y = meshresults[1]; 
-	var z = meshresults[2]; 
-	var elements = meshresults[3]; 
-	var is2d = meshresults[4]; 
-	var isplanet = meshresults[5];
-	if (md.mesh.classname() !== 'mesh3dsurface') z = md.geometry.surface;
+	// Compute coordinates and data range
+	xlim = options.getfieldvalue('xlim', [ArrayMin(x), ArrayMax(x)]);
+	ylim = options.getfieldvalue('ylim', [ArrayMin(y), ArrayMax(y)]);
 	
-	//Compute coordinates and data range:
-	var xlim = options.getfieldvalue('xlim', [ArrayMin(x), ArrayMax(x)]);
-	var ylim = options.getfieldvalue('ylim', [ArrayMin(y), ArrayMax(y)]);
-	var zlim = options.getfieldvalue('zlim', [ArrayMin(md.geometry.surface), ArrayMax(md.geometry.surface)]);
-	
-	//Handle radaroverlay
+	// Handle radaroverlay
 	if (md.radaroverlay.outerx) {
-		var result = Node.prototype.mergeVertices(x, y, z, elements, md.radaroverlay.outerx, md.radaroverlay.outery, md.radaroverlay.outerheight, md.radaroverlay.outerindex);
-		x = result.x;
-		y = result.y;
-		z = result.z;
-		elements = result.elements;
+		result      = Node.prototype.mergeVertices(x, y, z, elements, md.radaroverlay.outerx, md.radaroverlay.outery, md.radaroverlay.outerheight, md.radaroverlay.outerindex);
+		x           = result.x;
+		y           = result.y;
+		z           = result.z;
+		elements    = result.elements;
 	}
 	
-	//Handle heightscale
-	var vertices, scale;
-	if (md.mesh.classname() !== 'mesh3dsurface') {
-		vertices = [x, y, z];
-		scale = [1, 1, options.getfieldvalue('heightscale', 1)];
-	}
-	else {
-		vertices = Node.prototype.scaleVertices(md, x, y, z, elements, options.getfieldvalue('heightscale', 1), options.getfieldvalue('maskregion',{'enabled':false}));
-		scale = [1, 1, 1];
+	// Handle heightscale
+	renderObject = options.getfieldvalue('render', {});
+	
+	if ('overlay' in renderObject && renderObject.overlay.reproject !== undefined) {
+		reproject = renderObject.overlay.reproject;
 	}
 	
-	//Compute gl variables:
-	var edgecolor = options.getfieldvalue('edgecolor', 'black');
-	var texture = initTexture(gl, options.getfieldvalue('overlay_image'));
-	var node = new Node(
+	if (reproject) {
+		//NOTE: This is being hardcoded for now, as we want to display Josh's greenland-ice-retreat model on a globe.
+		// If mesh3dprisims do not need to be displayed on a globe, add an option to the view/render objects to specify the reprojection.
+		// Currently, we are also hardcoding the reprojection from EPSG:3413 (WGS 84 / NSIDC Sea Ice Polar Stereographic North) to EPSG:4326 (WGS 84, standard 2d spherical projection))
+		// projection definitions are taken from http://epsg.io/XXXXX.js, where XXXXX is the projection number.
+		// Can be dynamically taken and retrieved via md.mesh.epsg, but again, hardcoded for efficiency.
+		proj4.defs("EPSG:3413","+proj=stere +lat_0=90 +lat_ts=70 +lon_0=-45 +k=1 +x_0=0 +y_0=0 +datum=WGS84 +units=m +no_defs"); // http://epsg.io/3413.js
+		//Don't need to redefine EPSG:4326, as it is defined by default - however, this is still included just in case.
+		// proj4.defs("EPSG:4326","+proj=longlat +datum=WGS84 +no_defs"); // http://epsg.io/4326.js
+		//Create empty copies of XYZ to avoid rescaling md.geomtery.surface in the case that z = md.geomtery.surface
+		newX = NewArrayFill(x.length, 0);
+		newY = NewArrayFill(x.length, 0);
+		newZ = NewArrayFill(x.length, 0);
+		
+		for (let i = 0; i < x.length; ++i) {
+			result      = proj4('EPSG:3413','EPSG:4326', [x[i], y[i]]);
+			position    = vesl.geo.geographicToCartesian(vesl.EARTH_RADIUS + z[i], result[1], result[0], true);
+			newX[i]     = position.x;
+			newY[i]     = position.y;
+			newZ[i]     = position.z;
+		}
+		
+		x           = newX;
+		y           = newY;
+		z           = newZ;
+		vertices    = Node.prototype.scaleVertices(md, x, y, z, elements, options.getfieldvalue('heightscale', 1), options.getfieldvalue('maskregion',{'enabled':false, 'reproject':reproject}), true);
+		scale       = [1, 1, 1];
+    } else {
+		vertices    = Node.prototype.scaleVertices(md, x, y, z, elements, options.getfieldvalue('heightscale', 1), options.getfieldvalue('maskregion',{'enabled':false, 'reproject':reproject}), true);
+		scale       = [1, 1, 1];
+	}
+	
+	// Compute coordinates and data range
+	xlim = options.getfieldvalue('xlim', [ArrayMin(x), ArrayMax(x)]);
+	ylim = options.getfieldvalue('ylim', [ArrayMin(y), ArrayMax(y)]);
+	
+	// Compute GL variables
+	let texture         = new THREE.TextureLoader().load(options.getfieldvalue('overlay_image'));
+	let groundEnabled   = false;
+	let name            = 'overlay';
+	
+	if ('ground' in renderObject) {
+    	groundEnabled = renderObject.ground.enabled;
+    }
+    
+	if ('overlay' in renderObject) {
+    	name = renderObject.overlay.name;
+    }
+    
+	let shaderName = groundEnabled ? 'ground' : 'overlay';
+	
+	let node = new Node(
 		'canvas', canvas,
 		'options', options,
-		'name', 'overlay',
-		'shaderName', 'ground' in options.getfieldvalue('render', {}) ? 'GroundFromSpace' : 'TexturedDiffuse',
-		'alpha', options.getfieldvalue('outeralpha', 1.0),
-		//'center', [(xlim[0] + xlim[1]) / 2, (ylim[0] + ylim[1]) / 2, md.mesh.classname() === 'mesh3dsurface' ? (zlim[0] + zlim[1]) / 2 : zlim[0]],
-		'center', [(xlim[0] + xlim[1]) / 2, (ylim[0] + ylim[1]) / 2, (zlim[0] + zlim[1]) / 2],
-		'ambientColor', [0.1, 0.1, 0.1 ,1.0],
-		'diffuseColor', [1.0, 1.0, 1.0 ,1.0],
-		'specularStrength', 0.0,
-		'maskEnabled', options.getfieldvalue('outermask','off') == 'on',
-		'maskHeight', options.getfieldvalue('outermaskheight', 150.0),
-		'maskColor', options.getfieldvalue('outermaskcolor',[0.0, 0.0, 1.0, 1.0]),
+		'md', md,
+		'name', name,
+		'shaderName', shaderName,
+		'opacity', options.getfieldvalue('outeropacity', 1.0),
+		'cullFace', THREE.DoubleSide,
 		'texture', texture,
-		'rotation', [-90, 0, 0],
 		'scale', scale
 	);
-	//}}}
+	canvas.overlayNode = node;
 
-	var xRange = xlim[1] - xlim[0];
-	var yRange = ylim[1] - ylim[0];
-	var coordArray = [new Array(x.length), new Array(x.length)];
+	let xRange      = xlim[1] - xlim[0];
+	let yRange      = ylim[1] - ylim[0];
+	let coordArray  = [new Array(x.length), new Array(x.length)];
 	
-	//generate mesh:
-	if (md.mesh.classname() == 'mesh3dsurface') {
-		var xyz, magnitude;
-		for(var i = 0; i < x.length; i++){
-			xyz = vec3.fromValues(vertices[0][i], vertices[1][i], vertices[2][i]);
-			magnitude = vec3.length(xyz);
+	// Generate mesh
+	if (reproject || md.mesh.classname().startsWith('mesh3d')) {
+		let magnitude   = 0;
+		let xyz         = null;
 		
-			coordArray[0][i] = Math.atan2(xyz[1], xyz[0]) / (2 * Math.PI) + 0.5;
-			coordArray[1][i] = Math.asin(xyz[2] / magnitude) / Math.PI + 0.5;
+		for (let i = 0; i < x.length; ++i) {
+			xyz                 = vec3.fromValues(vertices[0][i], vertices[1][i], vertices[2][i]);
+			magnitude           = vec3.length(xyz);
+		
+			coordArray[0][i]    = Math.atan2(xyz[1], xyz[0]) / (2 * Math.PI) + 0.5;
+			coordArray[1][i]    = Math.asin(xyz[2] / magnitude) / Math.PI + 0.5;
 		}
-	}
-	else {
-		for(var i = 0; i < x.length; i++){
+	} else {
+		for (let i = 0; i < x.length; ++i) {
 			coordArray[0][i] = (vertices[0][i] - xlim[0]) / xRange;
 			coordArray[1][i] = (vertices[1][i] - ylim[0]) / yRange;
 		}
 	}
+	
 	node.patch('Faces', elements, 'Vertices', vertices, 'FaceVertexCData', coordArray, 'FaceColor', 'interp');
-} //}}}
+}
Index: issm/trunk/src/m/plot/plot_overlay.py
===================================================================
--- issm/trunk/src/m/plot/plot_overlay.py	(revision 25994)
+++ issm/trunk/src/m/plot/plot_overlay.py	(revision 26744)
@@ -11,5 +11,5 @@
     from osgeo import gdal
 except ImportError:
-    print('osgeo/gdal for python not installed, plot_overlay is disabled')
+    print('OSGeo/GDAL for python not installed, plot_overlay is disabled')
 
 from processdata import processdata
@@ -19,6 +19,5 @@
 
 def plot_overlay(md, data, options, ax):
-    '''
-    Function for plotting a georeferenced image. Called from plot_manager by 
+    """Function for plotting a georeferenced image. Called from plot_manager by 
     call to plotmodel.
 
@@ -27,5 +26,5 @@
 
     See also: PLOTMODEL
-    '''
+    """
 
     x, y, z, elements, is2d, isplanet = processmesh(md, [], options)
Index: issm/trunk/src/m/plot/plot_quiver.js
===================================================================
--- issm/trunk/src/m/plot/plot_quiver.js	(revision 25994)
+++ issm/trunk/src/m/plot/plot_quiver.js	(revision 26744)
@@ -21,5 +21,7 @@
 	var is2d = meshresults[4]; 
 	var isplanet = meshresults[5];
-	if (md.mesh.classname() !== 'mesh3dsurface') z = md.geometry.surface;
+	if (!md.mesh.classname().startsWith('mesh3d')) {
+		z = md.geometry.surface;
+	}
 		
 	//Compute coordinates and data range:
@@ -35,10 +37,10 @@
 	//Handle heightscale
 	var vertices, scale;
-	if (md.mesh.classname() !== 'mesh3dsurface') {
+	if (!md.mesh.classname().startsWith('mesh3d')) {
 		vertices = [x, y, z];
 		scale = [1, 1, options.getfieldvalue('heightscale', 1)];
 	}
 	else {
-		vertices = Node.prototype.scaleVertices(md, x, y, z, elements, options.getfieldvalue('heightscale', 1), options.getfieldvalue('maskregion',{'enabled':false}));
+		vertices = Node.prototype.scaleVertices(md, x, y, z, elements, options.getfieldvalue('heightscale', 1), options.getfieldvalue('maskregion',{'enabled':false}), true);
 		scale = [1, 1, 1];
 	}
@@ -51,5 +53,5 @@
 		'name', 'quiver',
 		'shaderName', 'Colored',
-		'alpha', options.getfieldvalue('alpha', 1.0),
+		'opacity', options.getfieldvalue('opacity', 1.0),
 		//'center', [(xlim[0] + xlim[1]) / 2, (ylim[0] + ylim[1]) / 2, md.mesh.classname() === 'mesh3dsurface' ? (zlim[0] + zlim[1]) / 2 : zlim[0]],
 		'center', [(xlim[0] + xlim[1]) / 2, (ylim[0] + ylim[1]) / 2, (zlim[0] + zlim[1]) / 2],
